﻿using FarPoint.PDF;
using FarPoint.Win;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;
using FarPoint.Win.Spread.Design;
using GrapeCity.Core;
using GrapeCity.Spreadsheet;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Color = System.Drawing.Color;

namespace SpreadHeaderFormat
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.DataSource = GetData();
            //ColumnHeader
            for (int i = 0; i < fpSpread1.ActiveSheet.Columns.Count; i++)
            {
                fpSpread1.ActiveSheet.ColumnHeader.Cells[0, i].Renderer = new CustomCellType();
            }
            //RowHeader
            for (int i = 0; i < fpSpread1.ActiveSheet.Rows.Count; i++)
            {
                fpSpread1.ActiveSheet.RowHeader.Cells[i, 0].Renderer = new CustomCellType();
            }
        }


        private ObservableCollection<CustomData>  GetData()
        {
            var data = new ObservableCollection<CustomData>();
            for(int i=0;i<200;i++)
            {
                data.Add(new CustomData() { Id = i,Value=i });
            }
            return data;
        }
    }

    internal class CustomCellType : IRenderer
    {
        public bool CanBeOverflown()
        {
            throw new NotImplementedException();
        }

        public bool CanOverflow()
        {
            throw new NotImplementedException();
        }

        public Size GetPreferredSize(Graphics g, Size size, FarPoint.Win.Spread.Appearance appearance, object value, float zoomFactor)
        {
            throw new NotImplementedException();
        }

        public void PaintCell(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            var font = 14 * zoomFactor;
            float stringWidth =((float)(g.MeasureString("ID", new System.Drawing.Font("Calibri", font))).Width)/2f;
            g.DrawString(value.ToString(), new System.Drawing.Font("Calibri",font), Brushes.Red, new PointF(r.X +(((float)r.Width / 2f) - stringWidth)-5, r.Y-3));
        }
    }

    public class CustomData
    {
        public int Id { get; set; }
        public int Value { get; set; }
    }
}